//
// CombatRaiseCalc.js
// Calculates the number of raises (or miss/hit) for the token that is currently defined as a target (i.e. selected
// as a target using the right click mentu).
//
// User enters damage and AP.  That script then pulls information from targetted token to do calculations.
//

let diceDialog = new Dialog({
  title: 'Enter Number of Each Dice Set:',
  content: `
    <form class="flexcol">
      <div class="form-group">
        <label for="totalDamageLeaf">Damage:</label>
        <input type="text" name="totalDamageLeaf" placeholder="Enter Value">
      </div>
      <div class="form-group">
        <label for="armorPiercingLeaf">AP:</label>
        <input type="text" name="armorPiercingLeaf" placeholder="Enter Value">

      </div>
    </form>
  `,
  buttons: {
    no: {
      icon: '<i class="fas fa-times"></i>',
      label: 'Cancel'
    },
    yes: {
      icon: '<i class="fas fa-check"></i>',
      label: 'Roll',
      callback: (html) => {
        let damage = html.find('[name="totalDamageLeaf"]').val();
        let armorPiercing = html.find('[name="armorPiercingLeaf"]').val();

        //console.log(damage,armorPiercing);

        if (Array.from(game.user.targets).length != 1 && (macroSettings.displayOption == 1)) {
            ui.notifications.warn("No Target Selected");

        } else {

          let chatString = "<p>";

          // get target information to use in calculation
          let currentTarget = Array.from(game.user.targets)[0].actor;
          let toughness = Array.from(game.user.targets)[0].actor.system.stats.toughness.value;
          let armor = Array.from(game.user.targets)[0].actor.system.stats.toughness.armor;

          // get the base toughness without armor
          let toughnessNoArmor = toughness - armor;

          // Apply AP to armor
          let armorRemainder = armor - armorPiercing;
          if (armorRemainder < 0)
          {
            armorRemainder = 0;
          }

          chatString = chatString + `<p>Damage: ${damage} AP: ${armorPiercing}</p>
          <p>Target Toughness: ${toughness} Armor: ${armor}</p>
          `;

          // final toughness with modified armor
          let finalToughness = toughnessNoArmor + armorRemainder;

          let damageRemainder = damage - finalToughness;
          if (damageRemainder < 0) {
            chatString = chatString + "No Damage Taken";

          } else {

            chatString = chatString + "<p><b> Met Toughness -- ";

            // calculate number of raises based on remaining damage after toughness applied.
            let raises = Math.floor(damageRemainder / 4);
            chatString = chatString + " Raises: " + raises + "</b></p>";


          }
          chatString = chatString + "</p>";


          ChatMessage.create({ content: chatString });

        }



      }
    },
  },
  default: 'yes',
  close: () => {
    console.log('Example Dialog Closed');
  }
}).render(true);
