//
// SWAttackMacro.js
//
// Usage:  Selected token is the attacker, set target to be the target.
//
// This macro uses the information for a selected token (attacker) and a target (right click menu on token) 
// to fully execute an attack.  User get's a drop down for the weapon and the system determines if it is
// meleee or range, calcs the hit, calcs the damage, and displays hit or raise.
//

main();

async function main()
{

  // this boolean is used to determine if we exit the script due to an error
  let runScript = true;

  // Needs to be exactly one selection and one target
if (canvas.tokens.controlled.length != 1) {
  ui.notifications.warn("Need Exactly One Selected Token");
  runScript = false;
}
if (Array.from(game.user.targets).length != 1) {
  ui.notifications.warn("Need Exactly One Targetted Token");
  runScript = false;
}

if (runScript) {


// Selected token --> The attacker
let selected = canvas.tokens.controlled[0].document.actor;
// the target.  Right click and select as target.
let target = Array.from(game.user.targets)[0].actor

// Critical target attributes for hitting and damage
let targetToughness = target.system.stats.toughness.value;
let targetArmor = target.system.stats.toughness.armor;
let targetParry = target.system.stats.parry.value;  // This is a guess need to check

// Skills used for attacking - start with them defined as unskilled.
let shootingDie = 4;
let shootingMod = -2;
let fightingDie = 4;
let fightiingMod = -2;

// The strength of the selected token - the attacker
let selectedStr = selected.system.attributes.strength.die
//console.log("Str: " + selectedStr.sides);

//console.log ("Target: toughness" + targetToughness + " armor" + targetArmor);

// List of all items on character sheet - remember items can be gear, skills, etc. basically almost everything
// in foundry is an item.
let itemList = selected.items.values()

let weaponList = new Map();

for (item of itemList)
{
  console.log("Value:" + item.name + ":" + item.type + " System:" + item.system.damage);

  // for item "Shooting" this represents the shooting skill
  if (item.name == "Shooting")
  {
    shootingDie = item.system.die.sides;
    shootingMod = item.system.die.modifier;
    //console.log("Shooting:" + shootingDie + " " + shootingMod);

  }
  // for item "Fighting" this represents the fighting skill
  if (item.name == "Fighting")
  {
    fightingDie = item.system.die.sides;
    fightiingMod = item.system.die.modifier;
    //console.log("Fighting:" + fightingDie);

  }
  // the type being "weapon" represents a weapon the character has
  if (item.type == "weapon")
  {
    weaponList.set(item.name, [item.system.damage, item.system.actions.skill, item.system.ap]);
    //console.log ("item: " + item.name + " skill: " + item.system.actions.skill);
  }

}

// Setup the select item for the dialog - select from all the weapons
let weaponSelect = '<label for="weaponLeaf">Choose Weapon</label><select name="weaponLeaf" id="weaponLeaf" form="diceForm">';

for (item of weaponList.keys())
{
  weaponSelect = weaponSelect + `<option value="${item}">${item}</option>`;

}
weaponSelect = weaponSelect + "</select>";
// End creating the weapon select statement

//console.log(weaponSelect);

let form = `
    <form id="diceForm" class="flexcol">
      <div class="form-group">
        <label for="weaponLeaf">Weapon:</label>
        ${weaponSelect}
      </div>
      <div class="form-group">
        <label for="modLeaf">Attack Mod:</label>
        <input type="text" name="modLeaf" placeholder="Enter Modifier" value="0">

      </div>
      <div class="form-group">
        <label for="damageLeaf">Damage Mod:</label>
        <input type="text" name="damageLeaf" placeholder="Enter Modifier" value="0">

      </div>
    </form>
  `;

  let diceDialog = new Dialog({
    title: 'Enter Number of Each Dice Set:',
    content: form,
    buttons: {
      no: {
        icon: '<i class="fas fa-times"></i>',
        label: 'Cancel'
      },
      yes: {
        icon: '<i class="fas fa-check"></i>',
        label: 'Roll',
        callback: async (html) => {
          let weapon = html.find('[name="weaponLeaf"]').val();
          let modifier = html.find('[name="modLeaf"]').val();
          let damageModifier = html.find('[name="damageLeaf"]').val();

          console.log ("Form Information:...> Weapon/Mod" + weapon + "/" + modifier);

          // Start with the text for the chat Message.
          let chatString = `
          <div>
            <div class="chat-header-box">

              <div class="pl-5">
                  <span> <b>${selected.name}</b> attacks <b>${target.name}</b></span>
              </div>
            </div>
            <div class="chat-content-box text-center">
            <div class="flex">
                <div class="flex-colum">

          `;
           chatString = chatString + "<p>";

          // Get weapon attributers to use for attacks
          let weaponSkill = weaponList.get(weapon)[1];
          let weaponDamage = weaponList.get(weapon)[0];
          let AP = weaponList.get(weapon)[2];

          let targetNumber = 4;
          let isHit = false;
          let isRaise = false;



          // if fighting we do all the rolls against the parry.
          if ("Fighting" == weaponSkill)
          {
           let xmod = parseInt(modifier) + parseInt(fightiingMod);

            console.log ("Fighting Type Weapon!");
            let toHit = new Roll(`1d${fightingDie}x + @mod`, {mod: xmod});
            await toHit.evaluate();
            // did we hit?
            chatString = chatString + `
              <div class="title">
                <label><b>Fighting Roll ${toHit.total} with modifier ${fightiingMod} </b> versus Parry ${targetParry}</label>
              </div>
            `;
            //chatString = chatString + "<p>Fighting Roll " + toHit.total + " versus Parry " + targetParry;

            if (toHit.total >= targetParry) {
              isHit = true;
              if (toHit.total-4 >= targetParry) {
                isRaise = true;
              }

            }
          } else {
            console.log ("Shooting Type Weapon!");

            let xmod = parseInt(modifier) + parseInt(shootingMod);
            //console.log ("Modifier Total: " + xmod);
            let toHit = new Roll(`1d${shootingDie}x + @mod`, {mod: xmod});
            await toHit.evaluate();

            chatString = chatString + `
              <div class="title">
                <label><b>Shooting Roll ${toHit.total} with modifier ${shootingMod}</b> versus target 4</label>
              </div>
            `;

            //chatString = chatString + "<p>Shooting Roll " + toHit.total + " versus target 4";
            // did we hit?
            if (toHit.total >= 4) {
              isHit = true;
              if (toHit.total-4 >= 4) {
                isRaise = true;
              }

            }
          }

          if (!isHit) {
            chatString = chatString + " <p>-- Miss on Attack<p>";
          } else {
            chatString = chatString + " <p>-- <b>Hit on Attack</b></p>";

            console.log("Hit:" + isHit + " Raise:" + isRaise);
            console.log("Rolling Damage (" + weaponDamage + ") with AP (" + AP + ")");

            chatString = chatString + `
            <div class="container">
                   
                    <div class="flex-auto">
                        <div class="item" style="">
                            <label class="white">Rolling Damage (${weaponDamage}) with AP (${AP}) Modifier (${damageModifier})</label>
                        </div>
                   
            `;
 //           chatString = chatString + "</p><p>Rolling Damage (" + weaponDamage + ") with AP (" + AP + ") Modifier: (" + damageModifier +")<p>";
           
            // get damage for weapon
            let damageRoll = 0;
            // If fighting (melee) is used, the weapon likely has a "str" component.
            // there might be easier ways in API to magically use the STR informaiton from sheet but
            // I don't know it.
            if ("Fighting" == weaponSkill)
            {
              console.log("Strength Mod: " + selectedStr);
              let rollString = weaponDamage.replace("@str", "1d"+selectedStr.sides+"x");
              console.log("rollstring:" + rollString);
              damageRoll = new Roll(rollString + " + @damMod", {damMod: damageModifier});
            } else {
              damageRoll = new Roll(weaponDamage + " + @damMod", { damMod: damageModifier});

            }


            console.log("Rolled: " + damageRoll);

             await damageRoll.evaluate();
            damage = damageRoll.total;
            if (isRaise) {
              let bonusDamage = new Roll("1d6x");
              await bonusDamage.evaluate()
                damage += bonusDamage.total;
            }

            // Time to do all the damage comparisons to target's toughness/armor

            // Get the base toughness without armor
              let toughnessNoArmor = targetToughness - targetArmor;

              // Apply armor piercing
              let armorRemainder = targetArmor - AP;
              if (armorRemainder < 0)
              {
                armorRemainder = 0;
              }


              chatString = chatString + `


                          <div class="item" style="">
                              <label class="white">Damage: (${damage}) with AP (${AP})</label>
                          </div>
  
                 
                      <div class="item" style="">
                          <label class="white">Target Toughness: (${targetToughness}) with Armor (${targetArmor})</label>
                      </div>
     
              `;

              // Get final toughness after AP applied then see what the damage is compared to toughness
              let finalToughness = toughnessNoArmor + armorRemainder;

              let damageRemainder = damage - finalToughness;
              if (damageRemainder < 0) {
                chatString = chatString + "<p>No Damage Taken</p>";

              } else {

                chatString = chatString + "<p><b> Met Toughness -- ";

                let raises = Math.floor(damageRemainder / 4);
                chatString = chatString + " Raises: " + raises + "</b></p>";


              }
              chatString = chatString + "</div></div></div></div></p>";

            }

            ChatMessage.create({ content: chatString });

        }
      },
    },
    default: 'yes',
    close: () => {
      console.log('Example Dialog Closed');
    }
  }).render(true);
}
}
